import os
import string
import smtplib
import random
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart

BASE_DIR = os.path.dirname(os.path.abspath(__file__))
CUSTOMERS_FILE = os.path.join(BASE_DIR, "customers.txt")

def createUser(username, fullName, email):
    if not os.path.exists(CUSTOMERS_FILE):
        open(CUSTOMERS_FILE, 'w').close()  # Create the file if it doesn’t exist

    found = False
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()
        for line in data:
            user = line.strip('\n')
            userInfo = user.split(',')
            if username == userInfo[0]:
                print(f"User {username} Already Exists!")
                found = True
                break
        if found == False:
            with open(CUSTOMERS_FILE, 'a') as file:
                file.write(f'{username},{fullName},{email}\n')

def findUser(username):
    found = False
    clutter = 0
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()
        for line in data:
            user = line.strip('\n')
            userInfo = user.split(',')
            if username == userInfo[0]:
                print(f"User Found at {clutter + 1}th place.")
                found = True
                break
            clutter+=1
        if found == False:
            print("User Not Found!")

def verifyUser(username, senderMail, senderPassword):
    recipient_mail = ''
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()
        for line in data:
            user = line.strip('\n')
            userInfo = user.split(',')
            if username == userInfo[0]:
                recipient_mail = userInfo[2]
                fullName = userInfo[1]
                break
    
    # generate an otp
    length = 6
    characters = string.digits
    otp = ''.join(random.choice(characters) for _ in range(length))

    subject = "Your Verification Code"
    body = f"Your verification code is: {otp}"

    # Create the email message
    msg = MIMEMultipart()
    msg['From'] = senderMail
    msg['To'] = recipient_mail
    msg['Subject'] = subject
    msg.attach(MIMEText(body, 'plain'))

    try:
        verified = False
        # Connect to the Gmail SMTP server
        server = smtplib.SMTP('smtp.gmail.com', 587)
        server.starttls()
        server.login(senderMail, senderPassword)
        server.send_message(msg, senderMail, recipient_mail)
        server.quit()
        print(f"OTP sent to {recipient_mail}")
        checkOTP = input("Enter The OTP recieved : ")
        if checkOTP == otp:
            print("User Verified Successfuly!")
            verified = True
            with open(CUSTOMERS_FILE, 'r') as file:
                data = file.readlines()
                for line in data:
                    with open(CUSTOMERS_FILE, 'w') as file:
                        if line.strip('\n').split(',')[0] != username:
                            file.write(line)
                        else:
                            file.write(f'{username},{fullName},{recipient_mail},{verified}\n')
        else:
            print("Verification Failed - *Incorrect OTP*")
    except Exception as e:
        print(f"Failed to send email: {e}")

def deleteUser(username):
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()
    with open(CUSTOMERS_FILE, 'w') as file:
        for line in data:
            if line.strip('\n').split(',')[0] != username:
                file.write(line)
            else:
                continue
def editUsername(currentUsername, newUsername):
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()
        for line in data:
            with open(CUSTOMERS_FILE, 'w') as file:
                fullName = line.strip('\n').split(',')[1]
                email = line.strip('\n').split(',')[2]
                verified = line.strip('\n').split(',')[3]

                if line.strip('\n').split(',')[0] != currentUsername:
                    file.write(line)
                else:
                    file.write(f"{newUsername},{fullName},{email},{verified}")

def editMail(currentMail, newMail):
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()

        for line in data:
            with open(CUSTOMERS_FILE, 'w') as file:
                username = line.strip('\n').split(',')[0]
                fullName = line.strip('\n').split(',')[1]
                verified = line.strip('\n').split(',')[3]

                if line.strip('\n').split(',')[2] != currentMail:
                    file.write(line)
                else:
                    file.write(f"{username},{fullName},{newMail},{verified}")